# frozen_string_literal: true

require_relative 'context_params_wrapper'

module AwsAccountStatus
  module Actions
    # Unifies some common access patterns for the GraphQL context's params.
    class ContextParamsWrapper
      def initialize(context_params)
        @params = context_params
      end

      # Crates the joint entry identifier in the format:
      # "{customer_id}+{account_id}"
      # which is the interface used in the data access layer
      def entry_identifier
        "#{@params[:customer_id]}+#{@params[:account_id]}"
      end
    end
  end
end
