# frozen_string_literal: true

require 'redis'
require 'circuit_breaker'

module AwsAccountStatus
  module Clients
    class RegionServiceSupportRedis < ::AwsAccountStatus::Clients::Redis
      circuit_handler do |handler|
        # The number of failures needed to trip the breaker.
        handler.failure_threshold = 20
        # The period of time in seconds before attempting to reset the breaker.
        handler.failure_timeout = 10
        # How long in seconds can the call take before it's counted as a failure?
        handler.invocation_timeout = 1
      end
    end
  end
end
