# frozen_string_literal: true

require 'aws_account_status/actions'
require 'aws_account_status/graph_ql/types'
require 'container'
require 'cht-lib-fabric/helpers/graphql'
require 'cht-lib-fabric/helpers/graphql/metric_tracing'
require 'cht-lib-fabric/graphql/federation/types'

module AwsAccountStatus
  module GraphQL
    class Schema < ::GraphQL::Schema
      use ::Platform::Helpers::GraphQL::MetricTracing, client: Application[:wavefront]
      use ::GraphQL::Execution::Interpreter
      use ::GraphQL::Analysis::AST
      extend ::Platform::Helpers::GraphQL::RaiseError
      include ApolloFederation::Schema

      query Types::Query
      mutation Types::Mutation
    end
  end
end
