# frozen_string_literal: true

require 'active_support/dependencies/autoload'

require 'aws_account_status/graph_ql/types/aws_accounts_api_access_status'
require 'aws_account_status/graph_ql/types/filterable_extension'
require 'aws_account_status/graph_ql/types/sortable_extension'

module AwsAccountStatus
  module GraphQL
    module Types
      extend ActiveSupport::Autoload

      autoload :Query
      autoload :Mutation

      autoload :AwsAccountApiAccessStatus
      autoload :AwsAccountApiAccessStatusService
      autoload :AwsAccountApiAccessStatusRegion
      autoload :AwsAccountsApiAccessStatus
      autoload :AwsApiAccessStatus
      autoload :AwsApiAccessStatusOverview
      autoload :FilterableExtension
      autoload :Mutations
      autoload :RegionInfo
      autoload :Resolvers
      autoload :ServiceSupportStatus
      autoload :SortableExtension
      autoload :UpdateRegionsPayload
      autoload :UpdateRegionsInput
      autoload :UpdateSpendlessRegionsInput
      autoload :UpdateSupportedServiceResult
      autoload :UpdateSupportedServicesInput
    end
  end
end
