require 'cht-lib-fabric/graphql/federation/types'

module AwsAccountStatus
  module GraphQL
    module Types
      class AwsAccountsApiAccessStatus < ::Platform::GraphQL::Types::BaseObject
        field :id, String, null: false, description: "Account Crn for the Aws Account"
        field :inaccessible_api_count, Integer, null: true, description: "Number of inaccessible APIs for the account. Filtering is supported."
        field :accessible_api_count, Integer, null: true
        field :name, String, null: true, description: "Name of the account"
        field :status, String, null: true, description: "This represents current health status of the Aws Account."
      end

      class AwsAccountsApiAccessStatusEdge < ::GraphQL::Types::Relay::BaseEdge
        node_type(AwsAccountsApiAccessStatus)
      end

      class AwsAccountsApiAccessStatusConnection < ::GraphQL::Types::Relay::BaseConnection
        edge_type(AwsAccountsApiAccessStatusEdge)

        field :count, Integer, null: false

        def count
          object.nodes&.count
        end
      end

      class AwsAccountsApiAccessStatusRelayConnection < ::GraphQL::Relay::BaseConnection
        def cursor_from_node(item)
          item[:cursor]
        end

        def has_next_page
          @nodes.has_next_page
        end

        def has_previous_page
          @nodes.has_previous_page
        end

        def nodes
          @nodes.nodes
        end

        def start_cursor
          unless @nodes.start_cursor.empty?
            return @nodes.start_cursor
          end

          super
        end

        def end_cursor
          unless @nodes.start_cursor.empty?
            return @nodes.end_cursor
          end

          super
        end

        private

        def first
          nodes
        end

        def last
          nodes
        end

        def paged_nodes
          nodes
        end

        def sliced_nodes
          nodes
        end

      end

      class AwsAccountsApiAccessStatusResolverResult < ::Dry::Struct
        attribute :nodes, ::Platform::DryTypes::Array
        attribute :has_previous_page, ::Platform::DryTypes::Strict::Bool.default(false)
        attribute :has_next_page, ::Platform::DryTypes::Strict::Bool.default(false)

        attribute :start_cursor, ::Platform::DryTypes::Strict::String.default('')
        attribute :end_cursor, ::Platform::DryTypes::Strict::String.default('')
      end

      class << self
        ::GraphQL::Relay::BaseConnection.register_connection_implementation(
          ::AwsAccountStatus::GraphQL::Types::AwsAccountsApiAccessStatusResolverResult,
          ::AwsAccountStatus::GraphQL::Types::AwsAccountsApiAccessStatusRelayConnection
        )
      end
    end
  end
end
