module AwsAccountStatus
  module GraphQL
    module Types
      module Mutations
        class UpdateAwsAccountRegions < ::GraphQL::Schema::Mutation

          description "Input is full list of regions with status for given account, may update datastore and cache if changes detected"

          type(UpdateRegionsPayload)

          argument :input, UpdateRegionsInput, required: true

          def resolve(**args)
            resolver = ::Platform::Helpers::GraphQL::ActionResolver.new(
              ::AwsAccountStatus::Actions::UpdateAccountRegions
            )
            response = resolver.call(nil, args, context)
            { account_id: response['accountId'], update_result: response['updateResult'] }
          end
        end
      end
    end
  end
end
