module AwsAccountStatus
  module GraphQL
    module Types
      module Mutations
        class UpdateSpendlessRegions < ::GraphQL::Schema::Mutation
          field :update_result, String, null: false

          argument :input, Types::UpdateSpendlessRegionsInput, required: true

          def resolve(**args)
            resolver = ::Platform::Helpers::GraphQL::ActionResolver.new(
              ::AwsAccountStatus::Actions::UpdateSpendlessRegions
            )
            response = resolver.call(nil, args, context)
            { update_result: response['updateResult'] }
          end
        end
      end
    end
  end
end
