module AwsAccountStatus
  module GraphQL
    module Types
      module Resolvers
        class GetSpendlessRegionsResolver < BaseResolver
          type [String], null: false

          argument :customer_id, String, required: true
          argument :account_id, String, required: true
          argument :service, String, required: true
          argument :asset, String, required: true

          def resolve(**args)
            resolver = ::Platform::Helpers::GraphQL::ActionResolver.new(
              ::AwsAccountStatus::Actions::GetSpendlessRegions, :spendless_regions
            )
            resolver.call(nil, args, context)
          end
        end
      end
    end
  end
end
