# frozen_string_literal: true

require 'karafka'
require_relative 'consumers/api_status'

module AwsAccountStatus
  module Consumers
    autoload :ApiStatusConsumer, 'consumers/api_status'
  end
end

::Karafka::App.consumer_groups.draw do
  consumer_group :api_status do
    topic 'com.cloudhealthtech.cp.collection.api_status' do
      consumer ::AwsAccountStatus::Consumers::ApiStatusConsumer
      batch_consuming true
    end
  end
end
